require 'mongo'
require 'mongo-import'
require 'bson'
require 'active_support/time'
include Mongo
include MongoImport


module MongoUtility
  HOST = "localhost"
  PORT = 27017

  def removeCollection(collectionName, dbName)
    @db = Mongo::Connection.new(HOST, PORT).db(dbName)
    @db.collection(collectionName).remove
    puts "[removeCollection] removed All documents for " + collectionName
  end

  # def insertCollection(collectionName, dbName, fileName)
  #   snapshot fileName, :db => dbName, :collection => collectionName, :path => 'spec/snapshots'
  #   puts "[insertCollection] imported Collection " + collectionName
  # end

  def insertCollection(collectionName, dbName, filePath)
    command = 'mongorestore --collection ' + collectionName + ' --db ' + dbName + ' ' + filePath
    system command
    #puts "[insertCollection] imported Collection " + collectionName
  end

  def insertDocument(collectionName, dbName, document)
    db = Mongo::Connection.new(HOST, PORT).db(dbName)
    collection = db.collection(collectionName)
    collection.insert(document)
  end

  def resetCollection(collectionName, dbName, fileName)
    removeCollection(collectionName, dbName)
    insertCollection(collectionName, dbName, fileName)
    puts "[resetCollection] reset Collection " + collectionName
  end

  def retreiveAllDocumentsInCollection(collectionName, dbName)
    documentArray = []
    db = Mongo::Connection.new(HOST, PORT).db(dbName)
    documents = db.collection(collectionName).find()
    documents.each do | document |
      documentArray << document
    end
    return documentArray
  end

  def getDocumentByFields(dbName, collection, fieldHash)
    @db = Mongo::Connection.new(HOST, PORT).db(dbName)
    document = @db.collection(collection).find(fieldHash)
    docs = []
    document.each { |doc|
      docs <<  doc
    }

    return docs
  end

  def getDocumentByTitle(collectionName, dbName, titleName, columnName)
    @db = Mongo::Connection.new(HOST, PORT).db(dbName)
    document = @db.collection(collectionName).find({"title" => titleName}, :fields => [columnName])

    return document
  end

  def retrieveThisFieldInDocumentByTitle(collectionName, dbName, titleName, columnName)
    document = getDocumentByTitle(collectionName, dbName, titleName, columnName)

    for record in document
      puts "record[columnName]=" + record[columnName].to_s
      return record[columnName]
    end
  end

  def getDocumentByPatientIdentifier(collectionName, dbName, assigningAuthorityValue, uniqueIdValue, columnName)
    @db = Mongo::Connection.new(HOST, PORT).db(dbName)
    document = @db.collection(collectionName).find({"patientIdentifier.uniqueId" => uniqueIdValue, "patientIdentifier.assigningAuthority"=> assigningAuthorityValue}, :fields => [columnName])
    return document
  end

  def retrieveThisFieldInDocument(collectionName, dbName, assigningAuthorityValue, uniqueIdValue, columnName)
    document = getDocumentByPatientIdentifier(collectionName, dbName, assigningAuthorityValue, uniqueIdValue, columnName)

    for record in document
      #puts "record[columnName]=" + record[columnName].to_s
      return record[columnName]
    end
  end

  def setDefaultPreferencesForPatient(uniqueId)
    @db = Mongo::Connection.new(HOST, PORT).db("notificationsdb")
    documents = @db.collection("preferences")
    document = getDocumentByPatientIdentifier("preferences", "notificationsdb", "EDIPI", uniqueId, "timeZone")
    if(document.next() == nil)
      documents.insert({"patientIdentifier" => { "uniqueId" => uniqueId, "assigningAuthority"=> "EDIPI" }, "timeZone" => "(-05:00) America/New_York (Eastern)", "emailAddress" => "test@test.com"})
    end
  end

  def setDefaultNotificationPreferencesForPatient(uniqueId, firstName, lastName)
    @db = Mongo::Connection.new(HOST, PORT).db("notificationsdb")
    documents = @db.collection("notificationPreferences")
    document = getDocumentByPatientIdentifier("notificationPreferences", "notificationsdb", "EDIPI", uniqueId, "optInSelected")
    if(document.next() == nil)
      documents.insert({"patientIdentifier" => { "uniqueId" => uniqueId, "assigningAuthority"=> "EDIPI" }, "firstName" => firstName, "lastName" => lastName, "optInSelected" => true, "dateOfBirth" => {"format" => "MMM dd, yyyy", "value" => "Jan 19, 1900", "valid" => true}})
    end
  end

end
