require 'rubygems'
require 'watir-webdriver'
require 'page-object'

class LandingPage
  include PageObject

  #########################
  #unauthenticated landing
  #########################
  button(:login, :css => 'button[ng-click="beginLogon()"]')

  p(:s1, :css => '.starter-template p:nth-of-type(2)')
  p(:s2, :css => '.starter-template > span:nth-of-type(2) > p')
  p(:s3, :css => '.starter-template > p:nth-of-type(3)')
  p(:s4, :css => '.starter-template > p:nth-of-type(4)')
  h2(:welcomeText, :css => '.app-title')
  element(:displayedDate, :strong, :css => '.starter-template p:nth-of-type(1) strong')

  ########################
  #authenticated landing
  ########################
  h2(:welcomeTextAuth, :css => '.welcome div h2')
  p(:systemDateAuth, :css => '.welcome div strong:nth-of-type(1) > p')
  element(:horizontalLine, :hr, :css => '.welcome > div > hr')
  element(:summaryText, :strong, :css => '.welcome > div > strong:nth-of-type(2)')
  p(:disclaimerSec1, :css => '.welcome > div > p:nth-of-type(1)')
  p(:disclaimerSec2, :css => '.welcome > div > p:nth-of-type(2)')
  p(:unreadNotifications, :css => '.welcome .notifications p.unread-count')


  def getSummaryItemsCount()
    self.class.elements(:summaryItems, :div, :css => '.dashboard-wrapper > .dashboard')
    return summaryItems_elements.length
  end

  def retrieveSummaryValuesFromDashboard(num)

    for i in 1..self.getSummaryItemsCount()

      self.class.div(:summaryTitle, :css => '.dashboard-wrapper > div:nth-of-type(' + num.to_s + ') > div > .panel-body > .dashboard-title')
      self.class.div(:summaryReading, :css => '.dashboard-wrapper > div:nth-of-type(' + num.to_s + ') > div > .panel-body > .dashboard-amount')
      self.class.div(:summaryDate, :css => '.dashboard-wrapper > div:nth-of-type(' + num.to_s + ') > div > .panel-body > .dashboard-date')

      return [self.summaryTitle, self.summaryReading, self.summaryDate]
    end
  end

  #############################
  #phone view carousel control
  #############################
  button(:nextScreenBttn, :css => 'button[title="Next Image"]')
  button(:prevScreenBttn, :css => 'button[title="Previous Image"]')

  def getTotalPages()
    self.class.elements(:totalPages, :li, :css => '.carousel-indicators > li')
    return totalPages_elements.length
  end

  def verifyTheCorrectSummaryBoxDisplaysWhenClickingNext()
    verificationPassed = 0
    for i in 1..getTotalPages()

      self.class.element(:summaryBoxElement, :li, :css => '.carousel-indicators > li:nth-of-type(' + i.to_s + ')')
      self.class.element(:summaryBoxTitle, :h3, :css => '.carousel-inner > div:nth-of-type(' + i.to_s + ') > .panel-default > .panel-body .dashboard-title')
      if summaryBoxElement_element.attribute("title") == "Image " + i.to_s + " of 3"
        if (summaryBoxTitle == "Blood Pressure" and i == 1) or (summaryBoxTitle == "Weight" and i == 2) or (summaryBoxTitle == "Glucose" and i == 3)
          verificationPassed = verificationPassed + 1
        else
          verificationPassed = verificationPassed + 0
          puts "FAILED! Page#=" + i.to_s + "; DisplayedSummaryBoxTitle=" + summaryBoxTitle
          break
        end
      else
        verificationPassed = verificationPassed + 0
        puts "FAILED! Page#=" + i.to_s + "; DisplayedPageNum=" + summaryBoxElement_element.attribute("title")
        break
      end

      self.nextScreenBttn
      sleep 1
    end

    return verificationPassed
  end

  def hasUnreadNotificationsIcon()
    self.class.element(:bellIcon, :i, :css => '.icon-notification')
    return self.bellIcon?
  end

end