require 'watir-webdriver'
require 'page-object'

require_relative 'roa'
require_relative 'common_elements'

class LoginPage < Roa
  include PageObject
  include DBUtility

  text_field(:username, :id => 'name-c')
  text_field(:password, :id => 'password')
  button(:login, :id => 'loginButton')
  span(:loginAs, :css => 'span[ng-if="userName"]')
  h2(:loginTitle, :css => "h2")

  def initialize(driver)
    super(driver)
    @commonElements = CommonElement.new(driver)
  end

  def login_with(username, password, displayedName, patientID)
    setDefaultROAForPatient(patientID)
    Watir::Wait.until {login?}
    username_element.when_visible
    self.username= username
    self.password= password
    login
  end

  def login_without_passing_ROA(username, password)
    username_element.when_visible
    self.username= username
    self.password= password
    login
  end

end