require 'watir-webdriver'
require 'page-object'
require 'spreadsheet'

class Resources
  include PageObject

  button(:resourcesLink, :id => 'resources')
  p(:disclaimer, :css => '.modal-body > p')
  div(:urgentGroup, :css => '.alert-urgent')
  div(:accordion, :css => '.accessible-accordion')
  button(:ok, :css => 'button[ng-click="ok()"]')

  elements(:accordionToggleButtons, :div, :css => '.accessible-accordion div.panel .panel-heading')
  elements(:accordionSections, :div, :css => '.accessible-accordion div.panel .panel-body')
  elements(:accordionHeaders, :div, :css => 'accessible-accordion > .panel-group > div')


  def openAccordionByIndex(accordionIdx)
  	element = self.accordionToggleButtons_elements[accordionIdx]
  	element.click
  end

  def getAccordionHyperlink(accordionIdx, linkIdx)
  	localIdx = linkIdx + 1 #offset, since indices passed in start at 0, but nth-of-type selector starts at 1
  	self.class.link(:localLink, :css => 'accessible-accordion .panel-body li:nth-of-type(' + localIdx.to_s + ') a')
  	return self.localLink_element
  end

  def getAccordionHeader(accordionIdx)
  	header = self.accordionHeaders_elements[accordionIdx]
  	return header.attribute('heading')
  end

end