require 'watir-webdriver'
require 'page-object'

require_relative 'common_elements'
require_relative 'modal_dialog'
require_relative '../module/DriverUtility'

class RightSideNav < CommonElement
  include PageObject
  include DriverUtility

  button(:userMenuBttn, :id => 'user-menu-toggle-btn')
  button(:about, :id => 'about')
  button(:help, :id => 'help')
  button(:launchpad, :id => 'launchpad')
  button(:login, :id => 'login')
  button(:logout, :id => 'logout')
  h2(:menuheader, :css => '.snap-drawer-right .panel-header h2:nth-of-type(1)')
  link(:feedbackToVA, :text => 'General Feedback to VA')
  link(:userGuide, :css => 'a[ng-click="showUserGuide()"]')
  h1(:feedbackSiteHeader, :css => '#mainContentWrapper h1')

  def initialize(driver)
    super(driver)
    @modal = Modal.new(driver)
  end

  def getAppNameFromAbout()
    origArry = @modal.appNameVersion.split(" - ")
    return origArry[0]
  end

  def getVersionNumFromAbout()
    origArry = @modal.appNameVersion.split(" - ")
    return origArry[1]
  end

end