require 'watir-webdriver'
require 'page-object'

require_relative 'common_elements'
require_relative 'modal_dialog'
require_relative '../module/DriverUtility'

class UserGuide < CommonElement
  include PageObject
  include DriverUtility

  h1(:userGuideTitle, :css => '.terms-of-cond h1')
  h3(:userGuideContentsTitle, :css => '.terms-of-cond fieldset legend h3')
  elements(:userGuideContents, :a, :css => '.terms-of-cond fieldset ol.table-of-contents a')
  elements(:mainSectionHeaders, :h2, :css => '.terms-of-cond > section > h2')
  elements(:abbreviationRows, :td, :css => 'table.app-abb tr')

  def subsections(index)
    self.class.elements(:subsection, :section, :css => '.terms-of-cond > section:nth-of-type(' + (index + 1).to_s + ') > section')
    return subsection_elements
  end

end