define(['angular', 'app'], function (angular, app) {
	"use strict";
	app.service('localResourceDirectoryService', function ($http, $q, patient) {
		var directory = {},
			isReady;

		directory.fetch = function () {

			if (isReady) {
				return isReady.promise;
			}

			isReady = $q.defer();
			$q.all({patient : patient.fetch(), resources : $http.get("resources.json")})
				.then(function (responses) {
					var patient = responses.patient;
					var resources = responses.resources.data;
					var patientId = patient.patientIdentifier.uniqueId;
					var assigningAuthority = patient.patientIdentifier.assigningAuthority;
					resources.link.forEach(function (link) {
						directory[link.title] = link.href.replace("{ASSIGNING_AUTHORITY}", assigningAuthority).replace('{UNIQUE_ID}', patientId);
					});
					isReady.resolve(directory);
				}, function (error) {
					isReady.reject(error);
					isReady = null;
				});

			return isReady.promise;

		};

		return directory;
	});
});