define(['LandingController'], function () {
	'use strict';

	describe("The Landing Page controller", function () {
		var controller,
			scope,
			deferred,
			httpMock,
			patientServiceMock,
			resourceDirectoryServiceMock,
			globalDelayTrackerMock,
			trackersServiceMock,
			notificationsPreferencesServiceMock,
			focusServiceMock,
			dataPointers = {
				list: []
			};

		beforeEach(function () {
			module('angularTemplateApp');

			patientServiceMock = jasmine.createSpyObj('patient', ['fetch']);
			resourceDirectoryServiceMock = jasmine.createSpyObj('resourceDirectory', ['fetch']);
			globalDelayTrackerMock = jasmine.createSpyObj('globalDelayTracker', ['active']);
			focusServiceMock = jasmine.createSpyObj('focusService', ['focusMain']);
			trackersServiceMock = jasmine.createSpyObj('TrackersService', ['instance']);
			notificationsPreferencesServiceMock = jasmine.createSpyObj('NotificationsPreferencesService', ['getNotificationsPreferenceAndCount']);
			patientServiceMock.fetch.andReturn({then: function() {} });
			resourceDirectoryServiceMock.fetch.andReturn({then: function() {} });

			module(function ($provide) {
				$provide.value('patient', patientServiceMock);
				$provide.value('resourceDirectory', resourceDirectoryServiceMock);
				$provide.value('globalDelayTracker', globalDelayTrackerMock);
				$provide.value('focusService', focusServiceMock);
				$provide.value('TrackersService', trackersServiceMock);
				$provide.value('NotificationsPreferencesService', notificationsPreferencesServiceMock);
			});

			inject(function ($controller, $rootScope, $q, $httpBackend) {
				scope = $rootScope.$new();
				httpMock = $httpBackend;
				deferred = $q.defer();
				deferred.resolve({value: '100', updated: '01/01/2000'})

				trackersServiceMock.instance.andReturn({
					dataPointers: dataPointers,
					getLatest: function() { return deferred.promise }
				});

				controller = $controller('LandingController', {$scope: scope});
			});
		});

		it("should retrieve patient details", function () {
			expect(patientServiceMock.fetch).toHaveBeenCalled();
		});
	});
});