define(['angular', 'app', 'moment'], function (angular, app) {
	'use strict';
	app.controller('LandingController', function ($scope, $parse, $window, patient, globalDelayTracker, focusService, TrackersService, NotificationsPreferencesService) {
		$scope.patientData = {};
		$scope.globalDelayTracker = globalDelayTracker;
		$scope.notificationsDataPointers = NotificationsPreferencesService.dataPointers;

		focusService.focusMain();

		patient.fetch().then(function(result){
			$scope.patientData = result;
		});

		NotificationsPreferencesService.getNotificationsPreferenceAndCount();

		$scope.today = new Date();

		// array to store which slides are active, by default, first slide is active
		// this controller needs access to the active-ness of slides for 508 hiding reasons
		$scope.activeSlides = [true, false, false];

		if (!$scope.dashboard) {
			$scope.dashboard = [
				{
					id: "bp-pulse",
					title: "Blood Pressure",
					icon: "icon-health-bloodpressure",
					units: "mmHg",
					updatedField: "updated",
					expression: "entry[0].valueQuantity.value + '/' + entry[1].valueQuantity.value"
				},
				{
					id: "weight",
					title: "Weight",
					icon: "icon-health-weight",
					units: "lbs",
					updatedField: "recorded",
					expression: "valueQuantity.value"
				},
				{
					id: "glucose",
					title: "Glucose",
					icon: "icon-health-glucose",
					units: "mg/dl",
					updatedField: "recorded",
					expression: "valueQuantity.value"
				}
			];
			angular.forEach($scope.dashboard, function(item) {
				item.service = TrackersService.instance(item.id);
				item.service.getLatest();
			});

			$scope.xsScreenResolution = function () {
				return $window.innerWidth < 768;
			};

			$scope.value = function(item) {
				return $parse(item.expression)(item.service.latest);
			};
			$scope.updated = function(item) {
				return item.service.latest[item.updatedField];
			};
		}

	});
});