define([
		'app',
		'LearnMoreService',
		'LearnMoreConstants',
		'LearnMoreController'
	],
	function (app) {
		"use strict";

		app.config(function ($stateProvider) {
			$stateProvider
				.state('main.auth.two-panel.secondary-navigation.learn-more', {
					url: '/learn-more',
					appNavIndex: 4,
					data: {
						moduleName: "Learn More",
						panel: "secondary",
						baseStateName : 'main.auth.two-panel.secondary-navigation.learn-more',
						initialState : "summary",
						paramSections : [
							{
								paramValue : "kidney-info",
								sectionName : "Kidney Info",
								sectionIndex : 1
							}, {
								paramValue : "nutrition",
								sectionName : "Nutrition",
								sectionIndex : 2
							}, {
								paramValue : "laboratory",
								sectionName : "Laboratory",
								sectionIndex : 3
							}, {
								paramValue : "social-work-services",
								sectionName : "Social Work Services",
								sectionIndex : 4
							}, {
								paramValue : "pharmacy",
								sectionName : "Pharmacy",
								sectionIndex : 5
							}, {
								paramValue : "treatment",
								sectionName : "Treatment",
								sectionIndex : 6
							}
						]
					},
					views : {
						'primary@main.auth.two-panel': {
							templateUrl: 'src/modules/learn-more/pages/learn-more-placeholder_template.html'
						}
					}
				})
				.state('main.auth.two-panel.secondary-navigation.learn-more.summary', {
					url: '/{section:kidney-info|nutrition|laboratory|social-work-services|pharmacy|treatment}/',
					data: {
						panel : "primary",
						backState : "^"
					},
					views : {
						'primary@main.auth.two-panel': {
							templateUrl: 'src/modules/learn-more/pages/learn-more_template.html',
							controller: 'LearnMoreController'
						}
					}
				});
		});
	}
);
