define(["angular", "app"], function (angular, app) {
	"use strict";

	app.controller("LearnMoreController", function ($scope, $state, $stateParams, $filter, $http, LearnMoreConstants) {
		$scope.sectionTitle = $state.current.data.sectionName || $filter('filter')($state.current.data.paramSections, { paramValue: $stateParams.section }, true)[0].sectionName;
		$scope.section = $stateParams.section;

		var sectionConstants = LearnMoreConstants[$scope.section]; 
		
		$scope.sectionIntro = sectionConstants.introduction;
		$scope.accordionSections = sectionConstants.sections;

		$scope.accordionSections.forEach(function(section){
			if (!section.quiz && section.quizUrl) {
				$http.get(section.quizUrl)
					.then(function(result) {
						section.quiz = result.data;
					});
			}
		});
	});
});